var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
/// <reference path="./../../types.d.ts"/>
import React, { PureComponent } from 'react';
import Month from '../Month';
import DateInput from '../DateInput';
import { calcFocusDate, generateStyles, getMonthDisplayRange, inferAriaLabel, isSelectionComplete, renderWeekdays } from '../../utils';
import { enUS } from '../../locale';
import classnames from 'classnames';
import ReactList from 'react-list';
import { shallowEqualObjects } from 'shallow-equal';
import { addMonths, subMonths, isSameDay, addYears, setYear, setMonth, differenceInCalendarMonths, startOfMonth, endOfMonth, addDays, isSameMonth, differenceInDays, min, max, } from 'date-fns';
import defaultLocale from 'date-fns/locale/en-US';
import coreStyles, { DEFAULT_COLOR } from '../../styles';
import { isModeMapperKey, isSureRange, CLEAR_PREVIEW, IGNORE_PREVIEW } from '../../types';
var Calendar = /** @class */ (function (_super) {
    __extends(Calendar, _super);
    function Calendar(props) {
        var _this = _super.call(this, props) || this;
        _this.focusToDate = function (date, props, preventUnnecessary) {
            var _a, _b, _c;
            if (props === void 0) { props = _this.props; }
            if (preventUnnecessary === void 0) { preventUnnecessary = true; }
            if (!((_a = props.scroll) === null || _a === void 0 ? void 0 : _a.enabled)) {
                if (preventUnnecessary && props.preventSnapRefocus) {
                    var focusedDateDiff = differenceInCalendarMonths(date, _this.state.focusedDate);
                    var isAllowedForward = props.calendarFocus === 'forwards' && focusedDateDiff >= 0;
                    var isAllowedBackward = props.calendarFocus === 'backwards' && focusedDateDiff <= 0;
                    if ((isAllowedForward || isAllowedBackward) && Math.abs(focusedDateDiff) < props.months) {
                        return;
                    }
                }
                _this.setState({ focusedDate: date });
                return;
            }
            var targetMonthIndex = differenceInCalendarMonths(date, props.minDate);
            var visibleMonths = (_b = _this.list) === null || _b === void 0 ? void 0 : _b.getVisibleRange();
            if (preventUnnecessary && (visibleMonths === null || visibleMonths === void 0 ? void 0 : visibleMonths.includes(targetMonthIndex)))
                return;
            _this.isFirstRender = true;
            (_c = _this.list) === null || _c === void 0 ? void 0 : _c.scrollTo(targetMonthIndex);
            _this.setState({ focusedDate: date });
        };
        _this.updateShownDate = function (props) {
            var _a, _b;
            if (props === void 0) { props = _this.props; }
            var newProps = ((_a = props.scroll) === null || _a === void 0 ? void 0 : _a.enabled)
                ? __assign(__assign({}, props), { months: ((_b = _this.list) === null || _b === void 0 ? void 0 : _b.getVisibleRange().length) || 0 }) : props;
            var newFocus = calcFocusDate(_this.state.focusedDate, newProps);
            _this.focusToDate(newFocus, newProps);
        };
        _this.updatePreview = function (val) {
            if (val === CLEAR_PREVIEW) {
                _this.setState({ previewRange: null });
                return;
            }
            var previewRange = {
                startDate: val,
                endDate: val,
                color: _this.props.color,
            };
            _this.setState({ previewRange: previewRange });
        };
        _this.changeShownDate = function (value, mode) {
            if (mode === void 0) { mode = 'set'; }
            var focusedDate = _this.state.focusedDate;
            var _a = _this.props, onShownDateChange = _a.onShownDateChange, minDate = _a.minDate, maxDate = _a.maxDate;
            if (value instanceof Date) {
                console.log(value, typeof value);
                throw new Error('value should always be a number, Date given');
            }
            var usableValue = (typeof value !== 'number')
                ? parseInt(value)
                : value;
            var modeMapper = {
                monthOffset: function () { return addMonths(focusedDate, usableValue); },
                setMonth: function () { return setMonth(focusedDate, usableValue); },
                setYear: function () { return setYear(focusedDate, usableValue); },
                set: function () { return usableValue; },
            };
            if (!isModeMapperKey(mode, modeMapper)) {
                console.log('mode: ', mode);
                throw new Error('Unsupported mode');
            }
            var newDate = min([max([modeMapper[mode](), minDate]), maxDate]);
            _this.focusToDate(newDate, _this.props, false);
            onShownDateChange && onShownDateChange(newDate);
        };
        _this.handleRangeFocusChange = function (rangesIndex, rangeItemIndex) {
            _this.props.onRangeFocusChange && _this.props.onRangeFocusChange([rangesIndex, rangeItemIndex]);
        };
        _this.handleScroll = function () {
            var _a;
            var _b = _this.props, onShownDateChange = _b.onShownDateChange, minDate = _b.minDate;
            var focusedDate = _this.state.focusedDate;
            var isFirstRender = _this.isFirstRender;
            var visibleMonths = (_a = _this.list) === null || _a === void 0 ? void 0 : _a.getVisibleRange();
            // prevent scroll jump with wrong visible value
            if (visibleMonths === undefined || visibleMonths[0] === undefined)
                return;
            var visibleMonth = addMonths(minDate, visibleMonths[0] || 0);
            var isFocusedToDifferent = !isSameMonth(visibleMonth, focusedDate);
            if (isFocusedToDifferent && !isFirstRender) {
                _this.setState({ focusedDate: visibleMonth });
                onShownDateChange && onShownDateChange(visibleMonth);
            }
            _this.isFirstRender = false;
        };
        _this.renderMonthAndYear = function (focusedDate, changeShownDate, props) {
            var showMonthArrow = props.showMonthArrow, minDate = props.minDate, maxDate = props.maxDate, showMonthAndYearPickers = props.showMonthAndYearPickers, ariaLabels = props.ariaLabels;
            var upperYearLimit = (maxDate || Calendar.defaultProps.maxDate).getFullYear();
            var lowerYearLimit = (minDate || Calendar.defaultProps.minDate).getFullYear();
            var styles = _this.styles;
            return (React.createElement("div", { onMouseUp: function (e) { return e.stopPropagation(); }, className: styles.monthAndYearWrapper },
                showMonthArrow ? (React.createElement("button", { type: "button", className: classnames(styles.nextPrevButton, styles.prevButton), onClick: function () { return changeShownDate(-1, 'monthOffset'); }, "aria-label": ariaLabels === null || ariaLabels === void 0 ? void 0 : ariaLabels.prevButton },
                    React.createElement("i", null))) : null,
                showMonthAndYearPickers ? (React.createElement("span", { className: styles.monthAndYearPickers },
                    React.createElement("span", { className: styles.monthPicker },
                        React.createElement("select", { value: focusedDate.getMonth(), onChange: function (e) { return changeShownDate(e.target.value, 'setMonth'); }, "aria-label": ariaLabels === null || ariaLabels === void 0 ? void 0 : ariaLabels.monthPicker }, _this.state.monthNames.map(function (monthName, i) { return (React.createElement("option", { key: i, value: i }, monthName)); }))),
                    React.createElement("span", { className: styles.monthAndYearDivider }),
                    React.createElement("span", { className: styles.yearPicker },
                        React.createElement("select", { value: focusedDate.getFullYear(), onChange: function (e) { return changeShownDate(e.target.value, 'setYear'); }, "aria-label": ariaLabels === null || ariaLabels === void 0 ? void 0 : ariaLabels.yearPicker }, new Array(upperYearLimit - lowerYearLimit + 1)
                            .fill(upperYearLimit)
                            .map(function (val, i) {
                            var year = val - i;
                            return (React.createElement("option", { key: year, value: year }, year));
                        }))))) : (React.createElement("span", { className: styles.monthAndYearPickers },
                    _this.state.monthNames[focusedDate.getMonth()],
                    " ",
                    focusedDate.getFullYear())),
                showMonthArrow ? (React.createElement("button", { type: "button", className: classnames(styles.nextPrevButton, styles.nextButton), onClick: function () { return changeShownDate(+1, 'monthOffset'); }, "aria-label": ariaLabels === null || ariaLabels === void 0 ? void 0 : ariaLabels.nextButton },
                    React.createElement("i", null))) : null));
        };
        _this.renderDateDisplay = function () {
            var _a = _this.props, focusedRange = _a.focusedRange, color = _a.color, ranges = _a.ranges, rangeColors = _a.rangeColors, dateDisplayFormat = _a.dateDisplayFormat, editableDateInputs = _a.editableDateInputs, startDatePlaceholder = _a.startDatePlaceholder, endDatePlaceholder = _a.endDatePlaceholder, ariaLabels = _a.ariaLabels;
            var defaultColor = rangeColors && rangeColors[focusedRange[0]] || color;
            var styles = _this.styles;
            return (React.createElement("div", { className: styles.dateDisplayWrapper }, ranges.map(function (range, i) {
                var _a, _b;
                if (range.showDateDisplay === false || (range.disabled && !range.showDateDisplay))
                    return null;
                return (React.createElement("div", { className: styles.dateDisplay, key: i, style: { color: range.color || defaultColor } },
                    React.createElement(DateInput, { className: classnames(styles.dateDisplayItem, (_a = {},
                            _a[styles.dateDisplayItemActive] = focusedRange[0] === i && isSelectionComplete(focusedRange),
                            _a)), readOnly: !editableDateInputs, disabled: range.disabled, value: range.startDate === null ? undefined : range.startDate, placeholder: startDatePlaceholder, dateOptions: _this.dateOptions, dateDisplayFormat: dateDisplayFormat, ariaLabel: inferAriaLabel(range, ariaLabels, 'startDate'), onChange: _this.onDragSelectionEnd, onFocus: function () { return _this.handleRangeFocusChange(i, 0); } }),
                    React.createElement(DateInput, { className: classnames(styles.dateDisplayItem, (_b = {},
                            _b[styles.dateDisplayItemActive] = focusedRange[0] === i && !isSelectionComplete(focusedRange),
                            _b)), readOnly: !editableDateInputs, disabled: range.disabled, value: range.endDate === null ? undefined : range.endDate, placeholder: endDatePlaceholder, dateOptions: _this.dateOptions, dateDisplayFormat: dateDisplayFormat, ariaLabel: inferAriaLabel(range, ariaLabels, 'endDate'), onChange: function (_) { return _this.onDragSelectionEnd; }, onFocus: function (_) { return _this.handleRangeFocusChange(i, 1); } })));
            })));
        };
        _this.onDragSelectionStart = function (date) {
            var _a = _this.props, onChange = _a.onChange, dragSelectionEnabled = _a.dragSelectionEnabled;
            if (dragSelectionEnabled) {
                _this.setState({
                    drag: {
                        status: true,
                        range: { startDate: date || null, endDate: date || null },
                        disablePreview: true,
                    },
                });
            }
            else {
                if (!date) {
                    throw new Error('Bug, expecting date to not be undefined');
                }
                onChange && onChange(date);
            }
        };
        _this.onDragSelectionEnd = function (date) {
            var _a = _this.props, updateRange = _a.updateRange, displayMode = _a.displayMode, onChange = _a.onChange, dragSelectionEnabled = _a.dragSelectionEnabled;
            if (!dragSelectionEnabled)
                return;
            if (displayMode === 'date' || !_this.state.drag.status) {
                onChange && onChange(date);
                return;
            }
            var drag = _this.state.drag;
            var newRange = {
                startDate: drag.range.startDate || date,
                endDate: date,
            };
            if (displayMode !== 'dateRange' || (newRange.startDate && date && isSameDay(newRange.startDate, date))) {
                _this.setState({ drag: { status: false, range: {}, disablePreview: false } }, function () { return onChange && onChange(date); });
            }
            else {
                _this.setState({ drag: { status: false, range: {}, disablePreview: drag.disablePreview } }, function () {
                    if (!isSureRange(newRange)) {
                        console.log(newRange);
                        throw new Error('Bug, expecting sure range, and found something else, likely a null range');
                    }
                    return updateRange && updateRange(newRange);
                });
            }
        };
        _this.onDragSelectionMove = function (date) {
            var drag = _this.state.drag;
            if (!drag.status || !_this.props.dragSelectionEnabled)
                return;
            _this.setState({
                drag: {
                    status: drag.status,
                    range: { startDate: drag.range.startDate, endDate: date },
                    disablePreview: true,
                },
            });
        };
        _this.estimateMonthSize = function (index, cache) {
            var _a = _this.props, direction = _a.direction, minDate = _a.minDate;
            var scrollArea = _this.state.scrollArea;
            if (cache) {
                _this.listSizeCache = cache;
                if (cache[index])
                    return cache[index];
            }
            if (direction === 'horizontal') {
                if (typeof scrollArea.monthWidth !== 'number') {
                    console.log(scrollArea);
                    throw new Error('scrollArea.monthWidth should be a number');
                }
                return scrollArea.monthWidth;
            }
            ;
            var monthStep = addMonths(minDate, index);
            var _b = getMonthDisplayRange(monthStep, _this.dateOptions), start = _b.start, end = _b.end;
            var isLongMonth = differenceInDays(end, start) + 1 > 7 * 5;
            if (isLongMonth) {
                if (undefined === scrollArea.longMonthHeight) {
                    throw new Error('scrollArea.longMonthWidth should be a number, but is undefined');
                }
                return scrollArea.longMonthHeight;
            }
            else {
                if (undefined === scrollArea.monthHeight) {
                    throw new Error('scrollArea.monthHeight should be a number, but is undefined');
                }
                return scrollArea.monthHeight;
            }
        };
        _this.dateOptions = __assign({ locale: _this.props.locale }, (_this.props.weekStartsOn !== undefined ? { weekStartsOn: _this.props.weekStartsOn } : {}));
        _this.styles = generateStyles([coreStyles, _this.props.classNames]);
        _this.listSizeCache = {};
        _this.isFirstRender = true;
        _this.list = null;
        var focusedDate = calcFocusDate(null, _this.props);
        _this.state = {
            monthNames: _this.getMonthNames(),
            focusedDate: focusedDate,
            drag: {
                status: false,
                range: { startDate: null, endDate: null },
                disablePreview: false,
            },
            scrollArea: _this.calcScrollArea(_this.props),
        };
        return _this;
    }
    Calendar.generateDefaultProps = function (referenceDate) {
        var refdate = referenceDate || new Date();
        return {
            referenceDate: refdate,
            ariaLabels: {
                monthPicker: "month picker",
                yearPicker: "year picker",
                prevButton: "previous month button",
                nextButton: "next month button",
            },
            calendarFocus: 'forwards',
            classNames: {},
            color: DEFAULT_COLOR,
            date: new Date(),
            dateDisplayFormat: 'MMM d, yyyy',
            dayDisplayFormat: 'd',
            direction: 'vertical',
            disabledDates: [],
            disabledDay: function () { return false; },
            displayMode: 'date',
            dragSelectionEnabled: true,
            editableDateInputs: false,
            endDatePlaceholder: 'Continuous',
            fixedHeight: false,
            focusedRange: [0, 0],
            locale: defaultLocale,
            maxDate: addYears(new Date(refdate.getTime()), 20),
            minDate: addYears(new Date(refdate.getTime()), -100),
            monthDisplayFormat: 'MMM yyyy',
            months: 1,
            preventSnapRefocus: false,
            rangeColors: ['#3d91ff', '#3ecf8e', '#fed14c'],
            ranges: [],
            scroll: {
                enabled: false,
            },
            showDateDisplay: true,
            showMonthAndYearPickers: true,
            showMonthArrow: true,
            showPreview: true,
            startDatePlaceholder: 'Early',
            weekdayDisplayFormat: 'E',
        };
    };
    Calendar.prototype.getMonthNames = function () {
        var locale = this.props.locale || enUS;
        return __spreadArray([], __read(Array(12).keys()), false).map(function (i) { var _a; return (_a = locale.localize) === null || _a === void 0 ? void 0 : _a.month(i); });
    };
    Calendar.prototype.calcScrollArea = function (props) {
        var direction = props.direction, months = props.months, scroll = props.scroll;
        if (!scroll.enabled)
            return { enabled: false };
        var longMonthHeight = scroll.longMonthHeight || scroll.monthHeight;
        return (direction === 'vertical')
            ? {
                enabled: true,
                monthHeight: scroll.monthHeight || 220,
                longMonthHeight: longMonthHeight || 260,
                calendarWidth: 'auto',
                calendarHeight: (scroll.calendarHeight || longMonthHeight || 240) * months,
            }
            : {
                enabled: true,
                monthWidth: scroll.monthWidth || 332,
                calendarWidth: (scroll.calendarWidth || scroll.monthWidth || 332) * months,
                monthHeight: longMonthHeight || 300,
                calendarHeight: longMonthHeight || 300,
            };
    };
    Calendar.prototype.componentDidMount = function () {
        var _this = this;
        if (this.props.scroll.enabled) {
            // prevent react-list's initial render focus problem
            setTimeout(function () { return _this.focusToDate(_this.state.focusedDate); });
        }
    };
    Calendar.prototype.componentDidUpdate = function (prevProps) {
        var displayMode = this.props.displayMode || 'date';
        var propMapper = {
            dateRange: 'ranges',
            date: 'date',
        };
        var targetProp = propMapper[displayMode];
        if (this.props[targetProp] !== prevProps[targetProp]) {
            this.updateShownDate(this.props);
        }
        if (prevProps.locale !== this.props.locale ||
            prevProps.weekStartsOn !== this.props.weekStartsOn) {
            this.dateOptions = { locale: this.props.locale };
            if (this.props.weekStartsOn !== undefined)
                this.dateOptions.weekStartsOn = this.props.weekStartsOn;
            this.setState({
                monthNames: this.getMonthNames(),
            });
        }
        if (!shallowEqualObjects(prevProps.scroll, this.props.scroll)) {
            this.setState({ scrollArea: this.calcScrollArea(this.props) });
        }
    };
    Calendar.prototype.render = function () {
        var _this = this;
        var _a = this.props, showDateDisplay = _a.showDateDisplay, onPreviewChange = _a.onPreviewChange, scroll = _a.scroll, direction = _a.direction, disabledDates = _a.disabledDates, disabledDay = _a.disabledDay, maxDate = _a.maxDate, minDate = _a.minDate, rangeColors = _a.rangeColors, color = _a.color, navigatorRenderer = _a.navigatorRenderer, className = _a.className, previewRange = _a.previewRange;
        var _b = this.state, scrollArea = _b.scrollArea, focusedDate = _b.focusedDate;
        var isVertical = direction === 'vertical';
        var monthAndYearRenderer = navigatorRenderer || this.renderMonthAndYear;
        var ranges = this.props.ranges.map(function (range, i) { return (__assign(__assign({}, range), { color: range.color || (rangeColors && rangeColors[i]) || color })); });
        return (React.createElement("div", { className: classnames(this.styles.calendarWrapper, className), onMouseUp: function () { return _this.setState({ drag: { status: false, range: {}, disablePreview: _this.state.drag.disablePreview } }); }, onMouseLeave: function () {
                _this.setState({ drag: { status: false, range: {}, disablePreview: _this.state.drag.disablePreview } });
            } },
            showDateDisplay && this.renderDateDisplay(),
            monthAndYearRenderer(focusedDate, this.changeShownDate, this.props),
            scroll.enabled ? (React.createElement("div", null,
                isVertical && renderWeekdays(this.styles, this.dateOptions, this.props.weekdayDisplayFormat),
                React.createElement("div", { className: classnames(this.styles.infiniteMonths, isVertical ? this.styles.monthsVertical : this.styles.monthsHorizontal), onMouseLeave: function () { return onPreviewChange && onPreviewChange(CLEAR_PREVIEW); }, style: {
                        width: (typeof scrollArea.calendarWidth === 'string' && scrollArea.calendarWidth) || 11 + typeof scrollArea.calendarWidth !== 'undefined' ? scrollArea.calendarWidth : 0,
                        height: 11 + (typeof scrollArea.calendarHeight !== 'undefined' ? scrollArea.calendarHeight : 0),
                    }, onScroll: this.handleScroll },
                    React.createElement(ReactList, { length: differenceInCalendarMonths(endOfMonth(maxDate), addDays(startOfMonth(minDate), -1)), threshold: 500, type: "variable", ref: function (target) { return (_this.list = target); }, itemSizeEstimator: this.estimateMonthSize, axis: isVertical ? 'y' : 'x', itemRenderer: function (index, key) {
                            var monthStep = addMonths(minDate, index);
                            return (React.createElement(Month, __assign({}, _this.props, { previewRange: (previewRange !== IGNORE_PREVIEW && previewRange) || _this.state.previewRange, ranges: ranges, key: key, drag: _this.state.drag, dateOptions: _this.dateOptions, disabledDates: disabledDates, disabledDay: disabledDay, month: monthStep, onDragSelectionStart: _this.onDragSelectionStart, onDragSelectionEnd: _this.onDragSelectionEnd, onDragSelectionMove: _this.onDragSelectionMove, onPreviewChange: onPreviewChange || _this.updatePreview, onMouseLeave: function (_) { onPreviewChange && onPreviewChange(CLEAR_PREVIEW); }, styles: _this.styles, style: isVertical
                                    ? { height: _this.estimateMonthSize(index) }
                                    : { height: scrollArea.monthHeight, width: _this.estimateMonthSize(index) }, showMonthName: true, showWeekDays: !isVertical })));
                        } })))) : (React.createElement("div", { className: classnames(this.styles.months, isVertical ? this.styles.monthsVertical : this.styles.monthsHorizontal) }, new Array(this.props.months).fill(null).map(function (_, i) {
                var monthStep = _this.props.calendarFocus === 'backwards'
                    ? subMonths(_this.state.focusedDate, _this.props.months - 1 - i)
                    : addMonths(_this.state.focusedDate, i);
                return (React.createElement(Month, __assign({}, _this.props, { onPreviewChange: onPreviewChange || _this.updatePreview, previewRange: previewRange || _this.state.previewRange, ranges: ranges, key: i, drag: _this.state.drag, dateOptions: _this.dateOptions, disabledDates: disabledDates, disabledDay: disabledDay, month: monthStep, onDragSelectionStart: _this.onDragSelectionStart, onDragSelectionEnd: _this.onDragSelectionEnd, onDragSelectionMove: _this.onDragSelectionMove, onMouseLeave: function () { return onPreviewChange && onPreviewChange(CLEAR_PREVIEW); }, styles: _this.styles, showWeekDays: !isVertical || i === 0, showMonthName: !isVertical || i > 0 })));
            })))));
    };
    Calendar.defaultProps = Calendar.generateDefaultProps();
    return Calendar;
}(PureComponent));
export default Calendar;
