var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
import React, { useEffect, useState } from 'react';
import DateRange from '../DateRange';
import { findNextRangeIndex, generateStyles } from '../../utils';
import classnames from 'classnames';
import coreStyles from '../../styles';
import StaticRanges from '../StaticRanges';
var defaultProps = {
    className: '',
};
var CollapsibleDateRangePicker = function (props) {
    var allProps = __assign(__assign({}, defaultProps), props);
    var classNames = allProps.classNames, className = allProps.className, ranges = allProps.ranges, collapse = allProps.collapse;
    var styles = generateStyles([coreStyles, classNames]);
    var _a = __read(useState((props.ranges && [findNextRangeIndex(props.ranges), 0]) || [0, 0]), 2), focusedRange = _a[0], setFocusedRange = _a[1];
    var _b = __read(useState(true), 2), collapsed = _b[0], setCollapsed = _b[1];
    var usableFocusedRange = allProps.focusedRange || focusedRange;
    var _c = __read(useState(), 2), nextPreviewRange = _c[0], setNextPreviewRange = _c[1];
    var onPreviewChange = allProps.onPreviewChange || setNextPreviewRange;
    useEffect(function () {
        if (collapse === undefined)
            return;
        setCollapsed(collapse);
    }, [setCollapsed, collapse]);
    var cname = classnames(styles.collapsibleCalendarWrapper, className);
    return (React.createElement("div", { className: __spreadArray([cname], __read((collapsed ? [cname + "--collapsed"] : [])), false).join(' ') },
        React.createElement("div", { className: styles.collapsibleCalendarHeader },
            React.createElement(StaticRanges, __assign({}, allProps, { focusedRange: usableFocusedRange, onPreviewChange: onPreviewChange, 
                // range={this.props.ranges[focusedRange[0]]}
                ranges: ranges })),
            React.createElement("button", { className: styles.collapsibleCalendarButton, type: "button", onClick: function (_) {
                    setCollapsed(!collapsed);
                } },
                React.createElement("i", null))),
        React.createElement("div", { className: styles.collapsibleCalendarBody },
            React.createElement(DateRange, __assign({}, allProps, { onPreviewChange: onPreviewChange, previewRange: nextPreviewRange, onRangeFocusChange: setFocusedRange, focusedRange: usableFocusedRange })))));
};
export default CollapsibleDateRangePicker;
