import React, { ChangeEvent, KeyboardEvent, PureComponent } from 'react';
import { DateOptions } from '../../types';
declare type FormatDateProps = {
    value?: Date;
    dateDisplayFormat: string;
    dateOptions?: DateOptions;
};
declare type CompontentProps = FormatDateProps & {
    placeholder?: string;
    disabled?: boolean;
    readOnly?: boolean;
    ariaLabel?: string;
    className?: string;
    onFocus: React.FocusEventHandler<HTMLInputElement>;
    onChange: (d: Date) => void;
};
declare type ComponentState = {
    invalid: boolean;
    changed: boolean;
    value: string;
};
declare class DateInput extends PureComponent<CompontentProps, ComponentState> {
    static defaultProps: {
        readOnly: boolean;
        disabled: boolean;
        dateDisplayFormat: string;
    };
    constructor(props: CompontentProps);
    componentDidUpdate(prevProps: CompontentProps): void;
    formatDate({ value, dateDisplayFormat, dateOptions }: FormatDateProps): string;
    update(value: string): void;
    onKeyDown: (e: KeyboardEvent<HTMLInputElement>) => void;
    onChange: (e: ChangeEvent<HTMLInputElement>) => void;
    onBlur: () => void;
    render(): JSX.Element;
}
export default DateInput;
//# sourceMappingURL=index.d.ts.map