var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import React, { PureComponent } from 'react';
import classnames from 'classnames';
import { format, parse, isValid, isEqual } from 'date-fns';
var DateInput = /** @class */ (function (_super) {
    __extends(DateInput, _super);
    function DateInput(props) {
        var _this = _super.call(this, props) || this;
        _this.onKeyDown = function (e) {
            var value = _this.state.value;
            if (e.key === 'Enter') {
                _this.update(value);
            }
        };
        _this.onChange = function (e) {
            _this.setState({ value: e.target.value, changed: true, invalid: false });
        };
        _this.onBlur = function () {
            var value = _this.state.value;
            _this.update(value);
        };
        _this.state = {
            invalid: false,
            changed: false,
            value: _this.formatDate(_this.props),
        };
        return _this;
    }
    DateInput.prototype.componentDidUpdate = function (prevProps) {
        var value = prevProps.value;
        if (typeof value !== 'undefined' && typeof this.props.value !== 'undefined' && !isEqual(value, this.props.value)) {
            this.setState({ value: this.formatDate(this.props) });
        }
    };
    DateInput.prototype.formatDate = function (_a) {
        var value = _a.value, dateDisplayFormat = _a.dateDisplayFormat, dateOptions = _a.dateOptions;
        if (value && isValid(value) && dateDisplayFormat) {
            return format(value, dateDisplayFormat, dateOptions);
        }
        return '';
    };
    DateInput.prototype.update = function (value) {
        var _a = this.state, invalid = _a.invalid, changed = _a.changed;
        if (invalid || !changed || !value) {
            return;
        }
        var _b = this.props, onChange = _b.onChange, dateDisplayFormat = _b.dateDisplayFormat, dateOptions = _b.dateOptions;
        var parsed = parse(value, dateDisplayFormat, new Date(), dateOptions);
        if (isValid(parsed)) {
            this.setState({ changed: false }, function () { return onChange(parsed); });
        }
        else {
            this.setState({ invalid: true });
        }
    };
    DateInput.prototype.render = function () {
        var _a = this.props, className = _a.className, readOnly = _a.readOnly, placeholder = _a.placeholder, ariaLabel = _a.ariaLabel, disabled = _a.disabled, onFocus = _a.onFocus;
        var _b = this.state, value = _b.value, invalid = _b.invalid;
        return (React.createElement("span", { className: classnames('rdrDateInput', className) },
            React.createElement("input", { readOnly: readOnly, disabled: disabled, value: value, placeholder: placeholder, "aria-label": ariaLabel, onKeyDown: this.onKeyDown, onChange: this.onChange, onBlur: this.onBlur, onFocus: onFocus }),
            invalid && React.createElement("span", { className: "rdrWarning" }, "\u26A0")));
    };
    DateInput.defaultProps = {
        readOnly: true,
        disabled: false,
        dateDisplayFormat: 'MMM D, YYYY',
    };
    return DateInput;
}(PureComponent));
export default DateInput;
