import React from 'react';
import { ClassNames } from '../../styles';
import { DateRangeProps, NotFullyEmptyRange, MaybeEmptyRange, RangeFocus, ClearPreview, IgnorePreview } from '../../types';
declare type DefaultComponentProps = {
    classNames?: Partial<ClassNames>;
    ranges?: NotFullyEmptyRange[];
    moveRangeOnFirstSelection?: boolean;
    retainEndDateOnFirstSelection?: boolean;
    rangeColors?: string[];
    disabledDates?: Date[];
};
export declare type DateRangeDCP = DefaultComponentProps;
declare type ComponentProps = DateRangeProps & DefaultComponentProps & {
    onRangeFocusChange?: (focusedRange: RangeFocus) => void;
};
export declare type DateRangeCP = ComponentProps;
export declare type RangeSelection = {
    wasValid: boolean;
    range: {
        startDate: Date;
        endDate: Date | null;
    };
    nextFocusRange: RangeFocus;
};
export declare const calcNewSelectionGen: (props: Readonly<ComponentProps>, stateFocusedRange: RangeFocus) => (value: Date | MaybeEmptyRange | IgnorePreview | ClearPreview) => RangeSelection | IgnorePreview | ClearPreview;
export declare const defaultProps: DefaultComponentProps;
export declare function getInitialFocusedRange(initialFocusedRange: ComponentProps["initialFocusedRange"], ranges: ComponentProps["ranges"]): RangeFocus;
declare const DateRange: React.FC<ComponentProps>;
export default DateRange;
//# sourceMappingURL=index.d.ts.map