var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
import React, { useState } from 'react';
import DateRange from '../DateRange';
import DefinedRange from '../DefinedRange';
import { findNextRangeIndex, generateStyles } from '../../utils';
import classnames from 'classnames';
import coreStyles from '../../styles';
var defaultProps = {
    className: '',
};
var DateRangePicker = function (props) {
    var allProps = __assign(__assign({}, defaultProps), props);
    var classNames = allProps.classNames, className = allProps.className, ranges = allProps.ranges;
    var styles = generateStyles([coreStyles, classNames]);
    var _a = __read(useState((props.ranges && [findNextRangeIndex(props.ranges), 0]) || [0, 0]), 2), focusedRange = _a[0], setFocusedRange = _a[1];
    var usableFocusedRange = allProps.focusedRange || focusedRange;
    var _b = __read(useState(), 2), nextPreviewRange = _b[0], setNextPreviewRange = _b[1];
    var onPreviewChange = allProps.onPreviewChange || setNextPreviewRange;
    return (React.createElement("div", { className: classnames(styles.dateRangePickerWrapper, className) },
        React.createElement(DefinedRange, __assign({}, allProps, { focusedRange: usableFocusedRange, onPreviewChange: onPreviewChange, 
            // range={this.props.ranges[focusedRange[0]]}
            ranges: ranges })),
        React.createElement(DateRange, __assign({}, allProps, { onPreviewChange: onPreviewChange, previewRange: nextPreviewRange, onRangeFocusChange: setFocusedRange, focusedRange: usableFocusedRange }))));
};
export default DateRangePicker;
