import React from 'react';
import { mount, shallow } from 'enzyme';
import DateRangePicker from '.';
describe('DateRangePicker tests', function () {
    test('Should call "renderStaticRangeLabel" callback 0 times', function () {
        var renderStaticRangeLabel = jest.fn();
        mount(React.createElement(DateRangePicker, { retainEndDateOnFirstSelection: false, weekStartsOn: 1, onChange: function (item) {
                if (!item || item.selection === undefined)
                    return;
                var selection = item.selection;
                renderStaticRangeLabel();
                console.log('selection start', selection.startDate);
                console.log('selection end', selection.endDate);
            } }));
        expect(renderStaticRangeLabel).toHaveBeenCalledTimes(0);
    });
    test('Should render', function () {
        Date.now = jest.fn(function () { return 1482363367071; });
        var wrapper = shallow(React.createElement(DateRangePicker, { retainEndDateOnFirstSelection: false, weekStartsOn: 0, onChange: function (item) {
                if (!item || item.selection === undefined)
                    return;
                var selection = item.selection;
                console.log('selection start', selection.startDate);
                console.log('selection end', selection.endDate);
            } }));
        expect(wrapper).toMatchSnapshot();
    });
});
