import classnames from 'classnames';
import { endOfDay, isAfter, isBefore, isSameDay, startOfDay } from 'date-fns';
import React from 'react';
var Preview = function (props) {
    var _a;
    var previewRange = props.previewRange, day = props.day, styles = props.styles;
    if (!previewRange)
        return null;
    var startDate = previewRange.startDate ? endOfDay(previewRange.startDate) : null;
    var endDate = previewRange.endDate ? startOfDay(previewRange.endDate) : null;
    var isInRange = (!startDate || isAfter(day, startDate))
        && (!endDate || isBefore(day, endDate));
    var isStartEdge = !isInRange && !!startDate && isSameDay(day, startDate);
    var isEndEdge = !isInRange && !!endDate && isSameDay(day, endDate);
    return (React.createElement("span", { className: classnames((_a = {},
            _a[styles.dayStartPreview] = isStartEdge,
            _a[styles.dayInPreview] = isInRange,
            _a[styles.dayEndPreview] = isEndEdge,
            _a)), style: { color: previewRange.color } }));
};
export default Preview;
