var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
import classnames from 'classnames';
import { isSameDay, isBefore, endOfDay, startOfDay, isAfter } from 'date-fns';
import React from 'react';
import { colorOpacity } from '../../../utils';
var Selection = function (props) {
    var styles = props.styles, ranges = props.ranges, day = props.day, displayMode = props.displayMode, date = props.date, color = props.color, isComplete = props.isComplete;
    if (displayMode === 'date') {
        var isSelected = date && isSameDay(day, date);
        return isSelected ? (React.createElement("span", { className: styles.selected, style: { color: color } })) : null;
    }
    var inRanges = ranges.reduce(function (result, range) {
        var st = range.startDate;
        var en = range.endDate;
        var _a = __read((st && en && isBefore(en, st)) ? [en, st] : [st, en], 2), start = _a[0], end = _a[1];
        var startDate = start ? endOfDay(start) : null;
        var endDate = end ? startOfDay(end) : null;
        var isInRange = (!startDate || isAfter(day, startDate)) && (!endDate || isBefore(day, endDate));
        var isStartEdge = !isInRange && !!startDate && isSameDay(day, startDate);
        var isEndEdge = !isInRange && !!endDate && isSameDay(day, endDate);
        if (isInRange || isStartEdge || isEndEdge) {
            return __spreadArray(__spreadArray([], __read(result), false), [
                __assign({ isStartEdge: isStartEdge, isEndEdge: isEndEdge, isInRange: isInRange }, range),
            ], false);
        }
        return result;
    }, []);
    return (React.createElement(React.Fragment, null, inRanges.map(function (range, i) {
        var _a;
        return (React.createElement("span", { key: i, className: classnames((_a = {},
                _a[styles.startEdge] = range.isStartEdge,
                _a[styles.endEdge] = range.isEndEdge,
                _a[styles.inRange] = range.isInRange,
                _a)), style: { color: colorOpacity((range.color || color || 'rgb(61, 145, 255)'), isComplete ? 1 : 0.5) } }));
    })));
};
export default Selection;
