import React from 'react';
import { PreviewRange, MaybeEmptyRange, ClearPreview } from '../../types';
import { CoreStyles } from '../../styles';
export declare type InRange = ({
    isStartEdge: boolean;
    isEndEdge: boolean;
    isInRange: boolean;
} & MaybeEmptyRange);
export declare type DateReceivingFunc = (date: Date) => void;
export declare type DateOrClearReceivingFunc = (date: Date | ClearPreview) => void;
declare type ComponentProps = SomeComponentProps & {
    color?: string;
    date?: Date;
    day: Date;
    dayContentRenderer?: DateReceivingFunc;
    dayDisplayFormat: string;
    displayMode?: 'dateRange' | 'date';
    isSelectionComplete: boolean;
    onMouseDown: DateReceivingFunc;
    onMouseEnter: DateReceivingFunc;
    onMouseUp: DateReceivingFunc;
    onPreviewChange?: DateOrClearReceivingFunc;
    previewRange?: PreviewRange | ClearPreview;
    previewColor?: string;
    ranges: MaybeEmptyRange[];
};
declare type SomeComponentProps = {
    disabled: boolean;
    isEndOfMonth: boolean;
    isEndOfWeek: boolean;
    isPassive: boolean;
    isStartOfMonth: boolean;
    isStartOfWeek: boolean;
    isToday: boolean;
    isWeekend: boolean;
    styles: CoreStyles;
};
declare const DayCell: React.FC<ComponentProps>;
export default DayCell;
//# sourceMappingURL=index.d.ts.map