var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
/* eslint-disable no-fallthrough */
import React, { useCallback, useState } from 'react';
import classnames from 'classnames';
import { format } from 'date-fns';
import { DEFAULT_DISPLAY_MODE, CLEAR_PREVIEW } from '../../types';
import Preview from './Preview';
import Selection from './Selection';
var getClassNames = function (_a) {
    var _b;
    var disabled = _a.disabled, isEndOfMonth = _a.isEndOfMonth, isEndOfWeek = _a.isEndOfWeek, isPassive = _a.isPassive, isStartOfMonth = _a.isStartOfMonth, isStartOfWeek = _a.isStartOfWeek, isToday = _a.isToday, isWeekend = _a.isWeekend, styles = _a.styles, hover = _a.hover, active = _a.active;
    return classnames(styles.day, (_b = {},
        _b[styles.dayPassive] = isPassive,
        _b[styles.dayDisabled] = disabled,
        _b[styles.dayToday] = isToday,
        _b[styles.dayWeekend] = isWeekend,
        _b[styles.dayStartOfWeek] = isStartOfWeek,
        _b[styles.dayEndOfWeek] = isEndOfWeek,
        _b[styles.dayStartOfMonth] = isStartOfMonth,
        _b[styles.dayEndOfMonth] = isEndOfMonth,
        _b[styles.dayHovered] = hover,
        _b[styles.dayActive] = active,
        _b));
};
var handleKeyEventGen = function (props) { return function (event) {
    var day = props.day, onMouseDown = props.onMouseDown, onMouseUp = props.onMouseUp;
    if ([13 /* space */, 32 /* enter */].includes(event.keyCode)) {
        if (event.type === 'keydown')
            onMouseDown(day);
        else
            onMouseUp(day);
    }
}; };
var handleMouseEventGen = function (props, setHover, setActive) { return function (event) {
    var day = props.day, disabled = props.disabled, onPreviewChange = props.onPreviewChange, onMouseEnter = props.onMouseEnter, onMouseDown = props.onMouseDown, onMouseUp = props.onMouseUp;
    if (disabled) {
        onPreviewChange && onPreviewChange(CLEAR_PREVIEW);
        return;
    }
    switch (event.type) {
        case 'mouseenter':
            onMouseEnter(day);
            onPreviewChange && onPreviewChange(day);
            setHover(true);
            break;
        case 'blur':
        case 'mouseleave':
            setHover(false);
            break;
        case 'mousedown':
            setActive(true);
            onMouseDown(day);
            break;
        case 'mouseup':
            event.stopPropagation();
            setActive(false);
            onMouseUp(day);
            break;
        case 'focus':
            onPreviewChange && onPreviewChange(day);
            break;
    }
}; };
var DayCell = function (props) {
    var _a = __read(useState(false), 2), hover = _a[0], setHover = _a[1];
    var _b = __read(useState(false), 2), active = _b[0], setActive = _b[1];
    var dayContentRenderer = props.dayContentRenderer, previewRange = props.previewRange, day = props.day, styles = props.styles, ranges = props.ranges, date = props.date, displayMode = props.displayMode, color = props.color, isSelectionComplete = props.isSelectionComplete;
    var handleMouseEvent = useCallback(handleMouseEventGen(props, setHover, setActive), [props, setHover, setActive]);
    var handleKeyEvent = useCallback(handleKeyEventGen(props), [props]);
    return (React.createElement("button", __assign({ type: "button", onMouseEnter: handleMouseEvent, onMouseLeave: handleMouseEvent, onFocus: handleMouseEvent, onMouseDown: handleMouseEvent, onMouseUp: handleMouseEvent, onBlur: handleMouseEvent, onPauseCapture: handleMouseEvent, onKeyDown: handleKeyEvent, onKeyUp: handleKeyEvent, className: getClassNames(__assign(__assign({}, props), { hover: hover, active: active })) }, (props.disabled || props.isPassive ? { tabIndex: -1 } : {}), { style: { color: props.color } }),
        React.createElement(Selection, { isComplete: isSelectionComplete, styles: styles, ranges: ranges, day: day, displayMode: displayMode || DEFAULT_DISPLAY_MODE, date: date, color: color }),
        React.createElement(Preview, { previewRange: previewRange, day: day, styles: styles }),
        React.createElement("span", { className: props.styles.dayNumber }, (dayContentRenderer && dayContentRenderer(props.day))
            || React.createElement("span", null, format(props.day, props.dayDisplayFormat)))));
};
export default DayCell;
