var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
import React, { useState } from 'react';
import styles from '../../styles';
import { defaultInputRanges, defaultStaticRanges, defaultInputRangesGen, defaultStaticRangesGen, DEFAULT_WEEK_STARTS_ON, REFERENCE_DATE } from '../../defaultRanges';
import InputRangeField from '../InputRangeField';
import classnames from 'classnames';
import StaticRanges, { handleRangeChangeGen } from '../StaticRanges';
var defaultProps = {
    ranges: [],
    staticRanges: defaultStaticRanges,
    inputRanges: defaultInputRanges,
    rangeColors: ['#3d91ff', '#3ecf8e', '#fed14c'],
    focusedRange: [0, 0],
    weekStartsOn: DEFAULT_WEEK_STARTS_ON,
};
var getRangeOptionValue = function (option, allProps) {
    var _a = allProps.ranges, ranges = _a === void 0 ? [] : _a, _b = allProps.focusedRange, focusedRange = _b === void 0 ? [] : _b;
    if (typeof option.getCurrentValue !== 'function')
        return '';
    var selectedRange = (focusedRange[0] && ranges[focusedRange[0]]) || {};
    return option.getCurrentValue(selectedRange) || '';
};
var DefinedRange = function (props) {
    var allProps = __assign(__assign({}, defaultProps), props);
    var weekStartsOn = allProps.weekStartsOn !== undefined && allProps.weekStartsOn || DEFAULT_WEEK_STARTS_ON;
    // commented out by g because unused
    // const [rangeOffset, setRangeOffset] = useState<number>(0);
    // const [focusedInput, setFocusedInput] = useState<number>(-1);
    var _a = __read(useState((allProps.weekStartsOn !== undefined && allProps.weekStartsOn !== DEFAULT_WEEK_STARTS_ON)
        ? {
            staticRanges: defaultStaticRangesGen({ weekStartsOn: weekStartsOn, referenceDate: REFERENCE_DATE }),
            inputRanges: defaultInputRangesGen({ weekStartsOn: weekStartsOn, referenceDate: REFERENCE_DATE }),
        }
        : {
            staticRanges: allProps.staticRanges || defaultStaticRanges,
            inputRanges: allProps.inputRanges || defaultInputRanges,
        }), 1), rangesRespectingWeekStartsOn = _a[0];
    var className = allProps.className, footerContent = allProps.footerContent, headerContent = allProps.headerContent, onPreviewChange = allProps.onPreviewChange, rangeColors = allProps.rangeColors, ranges = allProps.ranges, renderStaticRangeLabel = allProps.renderStaticRangeLabel;
    var inputRanges = rangesRespectingWeekStartsOn.inputRanges, staticRanges = rangesRespectingWeekStartsOn.staticRanges;
    var handleRangeChange = handleRangeChangeGen(allProps);
    return (React.createElement("div", { className: classnames(styles.definedRangesWrapper, className) },
        headerContent,
        React.createElement(StaticRanges, { ranges: ranges, staticRanges: staticRanges, onPreviewChange: onPreviewChange, rangeColors: rangeColors, renderStaticRangeLabel: renderStaticRangeLabel, handleRangeChange: handleRangeChange }),
        React.createElement("div", { className: styles.inputRanges }, inputRanges.map(function (rangeOption, i) { return (React.createElement(InputRangeField, { key: i, styles: styles, label: rangeOption.label, 
            // commented out by g because unused
            // onFocus={() => { setFocusedInput(i), setRangeOffset(0) }}
            // onBlur={() => setRangeOffset(0)}
            onFocus: function () { }, onBlur: function () { }, onChange: function (value) { return handleRangeChange(rangeOption.range(value, allProps)); }, value: getRangeOptionValue(rangeOption, allProps) })); })),
        footerContent));
};
export default DefinedRange;
