var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import React, { Component } from 'react';
var MIN = 0;
var MAX = 99999;
var InputRangeField = /** @class */ (function (_super) {
    __extends(InputRangeField, _super);
    function InputRangeField(props) {
        var _this = _super.call(this, props) || this;
        _this.onChange = function (e) {
            var value = parseInt(e.target.value, 10);
            var changeArg = isNaN(value) ? 0 : Math.max(Math.min(MAX, value), MIN);
            _this.props.onChange(changeArg);
        };
        return _this;
    }
    InputRangeField.prototype.shouldComponentUpdate = function (nextProps) {
        var _a = this.props, value = _a.value, label = _a.label, placeholder = _a.placeholder;
        return (value !== nextProps.value ||
            label !== nextProps.label ||
            placeholder !== nextProps.placeholder);
    };
    InputRangeField.prototype.render = function () {
        var _a = this.props, label = _a.label, placeholder = _a.placeholder, value = _a.value, styles = _a.styles, onBlur = _a.onBlur, onFocus = _a.onFocus;
        return (React.createElement("div", { className: styles.inputRange },
            React.createElement("input", { className: styles.inputRangeInput, placeholder: placeholder, value: value, min: MIN, max: MAX, onChange: this.onChange, onFocus: onFocus, onBlur: onBlur }),
            React.createElement("span", { className: styles.inputRangeLabel }, label)));
    };
    InputRangeField.defaultProps = {
        value: '',
        placeholder: '-',
    };
    return InputRangeField;
}(Component));
export default InputRangeField;
