import React, { MouseEvent, PureComponent } from 'react';
import { DateOrClearReceivingFunc, DateReceivingFunc } from '../DayCell';
import { CoreStyles } from '../../styles';
import { DateOptions, MaybeEmptyRange, RangeFocus, IgnorePreview, ClearPreview, PreviewRange } from '../../types';
export declare type Drag = {
    range: MaybeEmptyRange;
    status: boolean;
    disablePreview: boolean;
};
declare type ComponentProps = {
    dateOptions: DateOptions;
    dayDisplayFormat: string;
    disabledDates: Date[];
    disabledDay: (date: Date) => boolean;
    displayMode?: 'dateRange' | 'date';
    drag: Drag;
    fixedHeight: boolean;
    focusedRange: RangeFocus;
    maxDate: Date;
    minDate: Date;
    month: Date;
    monthDisplayFormat: string;
    onDragSelectionEnd: DateReceivingFunc;
    onDragSelectionMove: DateReceivingFunc;
    onDragSelectionStart: DateReceivingFunc;
    onMouseLeave: (e: MouseEvent<HTMLDivElement>) => void;
    onPreviewChange?: DateOrClearReceivingFunc;
    previewRange?: PreviewRange | IgnorePreview | ClearPreview;
    ranges: MaybeEmptyRange[];
    showMonthName: boolean;
    showPreview: boolean;
    showWeekDays: boolean;
    style?: React.CSSProperties;
    styles: CoreStyles;
    weekdayDisplayFormat: string;
};
declare class Month extends PureComponent<ComponentProps> {
    render(): JSX.Element;
}
export default Month;
//# sourceMappingURL=index.d.ts.map