var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React, { PureComponent } from 'react';
import DayCell from '../DayCell';
import { format, startOfDay, endOfDay, startOfWeek, endOfWeek, isBefore, isSameDay, isAfter, isWeekend, isWithinInterval, eachDayOfInterval, } from 'date-fns';
import { getMonthDisplayRange, isSelectionComplete, renderWeekdays } from '../../utils';
import { CLEAR_PREVIEW } from '../../types';
var Month = /** @class */ (function (_super) {
    __extends(Month, _super);
    function Month() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Month.prototype.render = function () {
        var _this = this;
        var now = new Date();
        var _a = this.props, dateOptions = _a.dateOptions, displayMode = _a.displayMode, month = _a.month, fixedHeight = _a.fixedHeight, focusedRange = _a.focusedRange, drag = _a.drag, styles = _a.styles, disabledDates = _a.disabledDates, disabledDay = _a.disabledDay, previewRange = _a.previewRange;
        var minDate = this.props.minDate && startOfDay(this.props.minDate);
        var maxDate = this.props.maxDate && endOfDay(this.props.maxDate);
        var monthDisplay = getMonthDisplayRange(month, dateOptions, fixedHeight);
        var ranges = this.props.ranges;
        if (displayMode === 'dateRange' && drag.status) {
            var _b = drag.range, startDate_1 = _b.startDate, endDate_1 = _b.endDate;
            ranges = ranges.map(function (range, i) {
                if (i !== focusedRange[0])
                    return range;
                return __assign(__assign({}, range), { startDate: startDate_1, endDate: endDate_1 });
            });
        }
        var showPreview = this.props.showPreview && !drag.disablePreview;
        return (React.createElement("div", { className: styles.month, style: this.props.style },
            this.props.showMonthName ? (React.createElement("div", { className: styles.monthName }, format(month, this.props.monthDisplayFormat, dateOptions))) : null,
            this.props.showWeekDays &&
                renderWeekdays(styles, dateOptions, this.props.weekdayDisplayFormat),
            React.createElement("div", { className: styles.days, onMouseLeave: this.props.onMouseLeave }, eachDayOfInterval({ start: monthDisplay.start, end: monthDisplay.end }).map(function (day, index) {
                var isStartOfMonth = isSameDay(day, monthDisplay.startDateOfMonth);
                var isEndOfMonth = isSameDay(day, monthDisplay.endDateOfMonth);
                var isOutsideMinMax = (minDate && isBefore(day, minDate)) || (maxDate && isAfter(day, maxDate));
                var isDisabledSpecifically = disabledDates.some(function (disabledDate) {
                    return isSameDay(disabledDate, day);
                });
                var isDisabledDay = disabledDay(day);
                return (React.createElement(DayCell, __assign({}, _this.props, { isSelectionComplete: isSelectionComplete(focusedRange), ranges: ranges, day: day, previewRange: previewRange && showPreview ? previewRange : CLEAR_PREVIEW, isWeekend: isWeekend(day), isToday: isSameDay(day, now), isStartOfWeek: isSameDay(day, startOfWeek(day, dateOptions)), isEndOfWeek: isSameDay(day, endOfWeek(day, dateOptions)), isStartOfMonth: isStartOfMonth, isEndOfMonth: isEndOfMonth, key: index, disabled: isOutsideMinMax || isDisabledSpecifically || isDisabledDay, isPassive: !isWithinInterval(day, {
                        start: monthDisplay.startDateOfMonth,
                        end: monthDisplay.endDateOfMonth,
                    }), styles: styles, onMouseDown: _this.props.onDragSelectionStart, onMouseUp: _this.props.onDragSelectionEnd, onMouseEnter: _this.props.onDragSelectionMove })));
            }))));
    };
    return Month;
}(PureComponent));
export default Month;
