import classnames from 'classnames';
import React from 'react';
import { CLEAR_PREVIEW } from '../../..';
import styles from '../../../styles';
import { hasRangeGen, isNotFullyEmptyRange } from '../../../types';
var StaticRangeButton = function (props) {
    var _a;
    var staticRange = props.staticRange, renderStaticRangeLabel = props.renderStaticRangeLabel, selectedRange = props.selectedRange, focusedRangeIndex = props.focusedRangeIndex, handleRangeChange = props.handleRangeChange, rangeColors = props.rangeColors, onPreviewChange = props.onPreviewChange;
    if (staticRange.hasCustomRendering && !renderStaticRangeLabel) {
        throw new Error('You should provide a renderStaticRangeLabel function when setting staticRange.hasCustomRendering = true');
    }
    if (!staticRange.label && !renderStaticRangeLabel) {
        throw new Error('Either provide a range with a label property or a renderStaticRangeLabel function to this component');
    }
    var labelContent = renderStaticRangeLabel && staticRange.hasCustomRendering
        ? renderStaticRangeLabel(staticRange)
        : staticRange.label;
    var actualStaticRange = hasRangeGen(staticRange) ? staticRange.range(props) : staticRange.range;
    if (!isNotFullyEmptyRange(actualStaticRange)) {
        console.log('staticRange: ', staticRange);
        console.log('range: ', staticRange.range);
        console.log('call.range()', staticRange.range());
        console.log(actualStaticRange);
        throw new Error('Expecting range to be a NotFullyEmptyRange, but found something different, possibly an empty range');
    }
    return (React.createElement("button", { type: "button", className: classnames(styles.staticRange, (_a = {},
            _a[styles.staticRangeSelected] = Boolean(selectedRange),
            _a)), style: {
            color: selectedRange
                ? selectedRange.color || (rangeColors && rangeColors[focusedRangeIndex])
                : undefined,
        }, onClick: function () { return handleRangeChange(actualStaticRange, props); }, onFocus: function () { return onPreviewChange && onPreviewChange(actualStaticRange); }, onMouseOver: function () {
            return onPreviewChange && onPreviewChange(actualStaticRange);
        }, onMouseLeave: function () {
            onPreviewChange && onPreviewChange(CLEAR_PREVIEW);
        } },
        React.createElement("span", { tabIndex: -1, className: styles.staticRangeLabel }, labelContent)));
};
export default StaticRangeButton;
