import React from 'react';
import { InputRangeWihLabel, NotFullyEmptyRange, MaybeEmptyRange, RangeFocus, StaticRange, WeekStartsOn, ClearPreview, PreviewRange, OnRangeChangeHandler } from '../../types';
export declare type StaticRangesHandleRangeChangeProps = {
    focusedRange?: RangeFocus;
    onChange?: OnRangeChangeHandler;
    ranges?: NotFullyEmptyRange[];
};
declare type ComponentProps = StaticRangesHandleRangeChangeProps & {
    className?: string;
    footerContent?: JSX.Element;
    handleRangeChange?: ReturnType<typeof handleRangeChangeGen>;
    headerContent?: JSX.Element;
    inputRanges?: InputRangeWihLabel[];
    onPreviewChange?: (r?: PreviewRange | ClearPreview) => void;
    rangeColors?: string[];
    renderStaticRangeLabel?: (r: StaticRange) => JSX.Element;
    staticRanges?: StaticRange[];
    weekStartsOn?: WeekStartsOn;
};
export declare type DefinedRangeCP = ComponentProps;
declare type DefaultComponentProps = StaticRangesInputRanges & {
    ranges: NotFullyEmptyRange[];
    rangeColors: string[];
    focusedRange: RangeFocus;
    weekStartsOn: WeekStartsOn;
};
export declare type StaticRangeDCP = DefaultComponentProps;
declare type StaticRangesInputRanges = {
    staticRanges: StaticRange[];
    inputRanges: InputRangeWihLabel[];
};
export declare const handleRangeChangeGen: (allProps: StaticRangesHandleRangeChangeProps) => (range: MaybeEmptyRange) => void;
declare const StaticRanges: React.FC<ComponentProps>;
export default StaticRanges;
//# sourceMappingURL=index.d.ts.map