var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
import React, { useState } from 'react';
import styles, { DEFAULT_COLOR } from '../../styles';
import { defaultInputRangesGen, defaultStaticRangesGen, REFERENCE_DATE } from '../../defaultRanges';
import { isSureRange } from '../../types';
import { defaultInputRanges, defaultStaticRanges, DEFAULT_WEEK_STARTS_ON } from '../../defaultRanges';
import StaticRangeButton from './StaticRangeButton';
var defaultProps = {
    ranges: [],
    staticRanges: defaultStaticRanges,
    inputRanges: defaultInputRanges,
    rangeColors: [DEFAULT_COLOR, '#3ecf8e', '#fed14c'],
    focusedRange: [0, 0],
    weekStartsOn: DEFAULT_WEEK_STARTS_ON,
};
function getSelectedRangeIndex(ranges, staticRanges) {
    return staticRanges.reduce(function (p, staticRange, sidx) {
        var focusedRangeIndex = ranges.findIndex(function (range) {
            if (!isSureRange(range) || range.disabled)
                return false;
            return staticRange.isSelected(range);
        });
        if (focusedRangeIndex < 0) {
            return p;
        }
        return { staticRangeIndex: sidx, focusedRangeIndex: focusedRangeIndex };
    }, { staticRangeIndex: -1, focusedRangeIndex: -1 });
}
function getSelectedRange(ranges, staticRange) {
    var focusedRangeIndex = ranges.findIndex(function (range) {
        if (!isSureRange(range) || range.disabled)
            return false;
        return staticRange.isSelected(range);
    });
    var selectedRange = ranges[focusedRangeIndex];
    return { selectedRange: selectedRange, focusedRangeIndex: focusedRangeIndex };
}
export var handleRangeChangeGen = function (allProps) { return function (range) {
    var _a;
    var onChange = allProps.onChange, ranges = allProps.ranges, focusedRange = allProps.focusedRange;
    var frange = focusedRange || [0, 0];
    var selectedRange = ranges && ranges[frange[0]];
    if (!onChange || !selectedRange)
        return;
    onChange((_a = {},
        _a[selectedRange.key || "range" + (frange[0] + 1)] = __assign(__assign({}, selectedRange), range),
        _a), frange[1] === 0);
}; };
var StaticRanges = function (props) {
    var allProps = __assign(__assign({}, defaultProps), props);
    var weekStartsOn = allProps.weekStartsOn !== undefined && allProps.weekStartsOn || DEFAULT_WEEK_STARTS_ON;
    var _a = __read(useState((allProps.weekStartsOn !== undefined && allProps.weekStartsOn !== DEFAULT_WEEK_STARTS_ON)
        ? {
            staticRanges: defaultStaticRangesGen({ weekStartsOn: weekStartsOn, referenceDate: REFERENCE_DATE }),
            inputRanges: defaultInputRangesGen({ weekStartsOn: weekStartsOn, referenceDate: REFERENCE_DATE }),
        }
        : {
            staticRanges: allProps.staticRanges || defaultStaticRanges,
            inputRanges: allProps.inputRanges || defaultInputRanges,
        }), 1), rangesRespectingWeekStartsOn = _a[0];
    var handleRangeChange = allProps.handleRangeChange, onPreviewChange = allProps.onPreviewChange, rangeColors = allProps.rangeColors, ranges = allProps.ranges, renderStaticRangeLabel = allProps.renderStaticRangeLabel;
    var staticRanges = rangesRespectingWeekStartsOn.staticRanges;
    var usableHandleRangeChange = handleRangeChange || handleRangeChangeGen(allProps);
    var staticRangeIndex = getSelectedRangeIndex(ranges || [], staticRanges).staticRangeIndex;
    return (React.createElement("div", { className: styles.staticRangesWrapper },
        React.createElement("div", { className: styles.staticRanges },
            staticRanges.map(function (staticRange, i) {
                var _a = getSelectedRange(ranges || [], staticRange), selectedRange = _a.selectedRange, focusedRangeIndex = _a.focusedRangeIndex;
                console.log('selectedRange, ', selectedRange, focusedRangeIndex);
                return (React.createElement(StaticRangeButton, { key: i, onPreviewChange: onPreviewChange, rangeColors: rangeColors, renderStaticRangeLabel: renderStaticRangeLabel, selectedRange: selectedRange, focusedRangeIndex: focusedRangeIndex, staticRange: staticRange, handleRangeChange: usableHandleRangeChange }));
            }),
            staticRangeIndex === -1
                ? React.createElement("span", { key: "custom-range", className: styles.staticRangeCustomSelection }, "Custom")
                : null)));
};
export default StaticRanges;
