import { InputRangeWihLabel, MaybeEmptyRange, WeekStartsOn, WithIsSelected, WithRangeOrRangeGen, NotFullyEmptyRange, RangeGen } from './types';
export declare const DEFAULT_WEEK_STARTS_ON: WeekStartsOn;
export declare const REFERENCE_DATE: Date;
declare type GenProps = {
    weekStartsOn: WeekStartsOn;
    referenceDate: Date;
};
export declare const definedsGen: ({ referenceDate, weekStartsOn }: GenProps) => DefinedDates;
declare type DefinedDates = {
    referenceDate: Date;
    startOfWeek: Date;
    endOfWeek: Date;
    startOfLastWeek: Date;
    endOfLastWeek: Date;
    startOfToday: Date;
    endOfToday: Date;
    startOfYesterday: Date;
    endOfYesterday: Date;
    startOfMonth: Date;
    endOfMonth: Date;
    startOfLastMonth: Date;
    endOfLastMonth: Date;
};
export declare const getDummyRange: RangeGen;
export declare function isSameRangeDay(someRange: MaybeEmptyRange, otherRange: MaybeEmptyRange): boolean;
export declare function extractRange(wr: WithRangeOrRangeGen): NotFullyEmptyRange;
export declare const staticRangeHandler: <B, U extends {
    [k: string]: B;
    [k: number]: B;
    [k: symbol]: B;
}, T extends WithRangeOrRangeGen & U>(withRangeOrRangeGen: T) => T & WithIsSelected;
export declare function createStaticRanges<B, U extends {
    [k: PropertyKey]: B;
}, T extends WithRangeOrRangeGen & U>(ranges: T[]): (T & WithIsSelected)[];
export declare const defaultStaticRangesGenerator: (defineds: DefinedDates) => ({
    label: string;
    range: () => {
        startDate: Date;
        endDate: Date;
    };
} & WithIsSelected)[];
export declare const defaultStaticRangesGen: (x0: GenProps) => ({
    label: string;
    range: () => {
        startDate: Date;
        endDate: Date;
    };
} & WithIsSelected)[];
export declare const defaultStaticRanges: ({
    label: string;
    range: () => {
        startDate: Date;
        endDate: Date;
    };
} & WithIsSelected)[];
export declare const defaultInputRangesGenerator: (defineds: DefinedDates) => InputRangeWihLabel[];
export declare const defaultInputRangesGen: (x0: GenProps) => InputRangeWihLabel[];
export declare const defaultInputRanges: InputRangeWihLabel[];
export {};
//# sourceMappingURL=defaultRanges.d.ts.map