/// <reference types="react" />
import { AriaLabelShape, DateOptions, MaybeEmptyRange, RangeFocus, SureStartSureEndDate } from './types';
import { ClassNames, CoreStyles } from './styles';
export declare type CalcFocusDateBaseProps = {
    months: number;
    shownDate?: Date;
    focusedRange?: number[];
};
export declare type CalcFocusDateRangeModeProps = CalcFocusDateBaseProps & {
    ranges: MaybeEmptyRange[];
    displayMode: 'dateRange';
};
export declare type CalcFocusDateModeProps = CalcFocusDateBaseProps & {
    date?: Date | number;
    ranges?: MaybeEmptyRange[];
    displayMode?: 'date';
};
export declare type CalcFocusDateProps = CalcFocusDateModeProps | CalcFocusDateRangeModeProps;
export declare function calcFocusDateRangeModeLastPart(currentFocusedDate: Date | null, months: number, startInput: Date | number, endInput?: Date | number | null, shownDate?: Date): Date;
export declare function calcFocusDateMode(currentFocusedDate: Date | null, { shownDate, date, months }: CalcFocusDateModeProps): Date;
export declare function calcFocusDateRangeMode(currentFocusedDate: Date | null, props: CalcFocusDateRangeModeProps): Date;
export declare function calcFocusDate(currentFocusedDate: Date | null, props: CalcFocusDateProps): Date;
export declare function calcFocusDateBis(currentFocusedDate: Date | null, props: CalcFocusDateProps): Date;
export declare function findNextRangeIndex(ranges: MaybeEmptyRange[], currentRangeIndex?: number): number;
declare type GetMonthDisplayRangeProp = {
    locale?: Locale;
    weekStartsOn?: 0 | 1 | 2 | 3 | 4 | 5 | 6;
};
export declare function getMonthDisplayRange(date: Date, dateOptions: GetMonthDisplayRangeProp, fixedHeight?: boolean): {
    start: Date;
    end: Date;
    startDateOfMonth: Date;
    endDateOfMonth: Date;
};
export declare function renderWeekdays(styles: CoreStyles, dateOptions: DateOptions, weekdayDisplayFormat: string): JSX.Element;
export declare const logger: {
    log(...args: any[]): void;
    mute(...args: any[]): void;
};
export declare type GeneratedStylesPropPart = CoreStyles | PartialStyles | {} | undefined;
export declare type PartialStyles = Partial<ClassNames>;
export declare function isStylesMap(s: GeneratedStylesPropPart): s is PartialStyles;
export declare function augmentStyles(styles: PartialStyles, augmentingStyles: PartialStyles): Partial<ClassNames>;
export declare function generateStyles(sources: [CoreStyles, PartialStyles | {} | undefined]): Partial<ClassNames>;
export declare function inferAriaLabel<T extends keyof SureStartSureEndDate<string>>(range: MaybeEmptyRange, ariaLabels: AriaLabelShape | undefined, key: T): string | undefined;
export declare function combineProps<T, U>(base: T, augmentOverwrite: U): T & U;
export declare function colorOpacity(color: string, opacity: number): string;
export declare function isSelectionComplete(focusedRange: RangeFocus): boolean;
export {};
//# sourceMappingURL=utils.d.ts.map