// import React from 'react';
// import { getByPlaceholderText, render } from '@testing-library/react';
// import { getByLabelText, fireEvent } from '@testing-library/dom';

// import InputRangeField from '.';

// const styles = {
//   inputRange: 'range',
//   inputRangeInput: 'input',
//   inputRangeLabel: 'label',
// };
// const toChangeEvent = (value: string | number) => ({ target: { value } });

// describe('InputRangeField tests', () => {
//   test('Should parse input value to number', () => {
//     const onChange = jest.fn();
//     const { container } = render(
//       <InputRangeField
//         label="Input label"
//         styles={styles}
//         onChange={onChange}
//         onFocus={jest.fn()}
//         onBlur={jest.fn()}
//       />
//     );
//     const input = getByPlaceholderText(container, 'Input label');

//     fireEvent.change(input, { target: { value: '3' } });
//     expect(onChange).lastCalledWith(3);
//     expect(input).toBe('3');
//     fireEvent.change(input, { target: { value: '12' } });
//     expect(onChange).lastCalledWith(12);
//     expect(input.value).toBe('12');
//     fireEvent.change(input, { target: { value: '' } });
//     expect(onChange).lastCalledWith(0);
//     expect(input.value).toBe('');
//     fireEvent.change(input, { target: { value: 'invalid number' } });
//     expect(onChange).lastCalledWith(0);
//     expect(input.value).toBe('invalid number');
//     fireEvent.change(input, { target: { value: -12 } });
//     expect(onChange).lastCalledWith(0);
//     expect(input.value).toBe('-12');
//     fireEvent.change(input, { target: { value: 99999999 } });
//     expect(onChange).lastCalledWith(99999);
//     expect(input.value).toBe('99999999');

//     expect(onChange).toHaveBeenCalledTimes(6);
//     expect(wrapper).toMatchSnapshot();
//   });

//   test('Should rerender when props change', () => {
//     const wrapper = mount(
//       <InputRangeField
//         value={12}
//         placeholder="Placeholder"
//         label="Input label"
//         styles={styles}
//         onChange={jest.fn()}
//         onFocus={jest.fn()}
//         onBlur={jest.fn()}
//       />
//     );

//     expect(wrapper.find(`.${styles.inputRangeInput}`).prop('value')).toEqual(12);
//     expect(wrapper.find(`.${styles.inputRangeInput}`).prop('placeholder')).toEqual('Placeholder');
//     expect(wrapper.find(`.${styles.inputRangeLabel}`).text()).toEqual('Input label');

//     wrapper.setProps({ value: '32' });
//     expect(wrapper.find(`.${styles.inputRangeInput}`).prop('value')).toEqual('32');
//     expect(wrapper.find(`.${styles.inputRangeInput}`).prop('placeholder')).toEqual('Placeholder');
//     expect(wrapper.find(`.${styles.inputRangeLabel}`).text()).toEqual('Input label');

//     wrapper.setProps({ placeholder: '-' });
//     expect(wrapper.find(`.${styles.inputRangeInput}`).prop('value')).toEqual('32');
//     expect(wrapper.find(`.${styles.inputRangeInput}`).prop('placeholder')).toEqual('-');
//     expect(wrapper.find(`.${styles.inputRangeLabel}`).text()).toEqual('Input label');

//     wrapper.setProps({ label: 'Label' });
//     expect(wrapper.find(`.${styles.inputRangeInput}`).prop('value')).toEqual('32');
//     expect(wrapper.find(`.${styles.inputRangeInput}`).prop('placeholder')).toEqual('-');
//     expect(wrapper.find(`.${styles.inputRangeLabel}`).text()).toEqual('Label');
//   });

//   test('Should render the label as a Component', () => {
//     const Label = () => <span className="input-range-field-label">Input label</span>;
//     const wrapper = mount(
//       <InputRangeField
//         value={12}
//         placeholder="Placeholder"
//         label={<Label />}
//         styles={styles}
//         onChange={jest.fn()}
//         onFocus={jest.fn()}
//         onBlur={jest.fn()}
//       />
//     );

//     expect(wrapper.find(`.${styles.inputRangeInput}`).prop('value')).toEqual(12);
//     expect(wrapper.find(`.${styles.inputRangeInput}`).prop('placeholder')).toEqual('Placeholder');
//     expect(wrapper.find(`.${styles.inputRangeLabel}`).text()).toEqual('Input label');
//     expect(wrapper.find(`.${styles.inputRangeLabel}`).text()).toEqual('Input label');
//     expect(wrapper.find(`.input-range-field-label`).text()).toEqual('Input label');

//     wrapper.setProps({ value: '32' });
//     expect(wrapper.find(`.${styles.inputRangeInput}`).prop('value')).toEqual('32');
//     expect(wrapper.find(`.${styles.inputRangeInput}`).prop('placeholder')).toEqual('Placeholder');
//     expect(wrapper.find(`.${styles.inputRangeLabel}`).text()).toEqual('Input label');

//     wrapper.setProps({ placeholder: '-' });
//     expect(wrapper.find(`.${styles.inputRangeInput}`).prop('value')).toEqual('32');
//     expect(wrapper.find(`.${styles.inputRangeInput}`).prop('placeholder')).toEqual('-');
//     expect(wrapper.find(`.${styles.inputRangeLabel}`).text()).toEqual('Input label');

//     wrapper.setProps({ label: 'Label' });
//     expect(wrapper.find(`.${styles.inputRangeInput}`).prop('value')).toEqual('32');
//     expect(wrapper.find(`.${styles.inputRangeInput}`).prop('placeholder')).toEqual('-');
//     expect(wrapper.find(`.${styles.inputRangeLabel}`).text()).toEqual('Label');
//   });
// });
